﻿-- Sparkwing Boss Mod for King Boss Mods
-- Written by Paul Snart
-- Copyright 2011
--

KBMEXFCSG_Settings = nil
chKBMEXFCSG_Settings = nil
-- Link Mods
local AddonData = Inspect.Addon.Detail("KingMolinator")
local KBM = AddonData.data
local Instance = KBM.BossMod["Foul Cascade"]

local MOD = {
	Directory = Instance.Directory,
	File = "Sparkwing.lua",
	Enabled = true,
	Instance = Instance.Name,
	InstanceObj = Instance,
	HasPhases = true,
	Lang = {},
	ID = "Sparkwing",
}

MOD.Sparkwing = {
	Mod = MOD,
	Level = 52,
	Active = false,
	Name = "Sparkwing",
	NameShort = "Sparkwing",
	Menu = {},
	Castbar = nil,
	Dead = false,
	-- TimersRef = {},
	-- AlertsRef = {},
	Available = false,
	UnitID = nil,
	TimeOut = 5,
	ExpertID = "Expert",
	Triggers = {},
	Settings = {
		CastBar = KBM.Defaults.CastBar(),
		-- TimersRef = {
			-- Enabled = true,
			-- Funnel = KBM.Defaults.TimerObj.Create("red"),
		-- },
		-- AlertsRef = {
			-- Enabled = true,
			-- Funnel = KBM.Defaults.AlertObj.Create("red"),
		-- },
	}
}

KBM.RegisterMod(MOD.ID, MOD)

MOD.Lang.Sparkwing = KBM.Language:Add(MOD.Sparkwing.Name)
MOD.Lang.Sparkwing:SetGerman("Funkenschwinge")
-- MOD.Lang.Sparkwing:SetFrench("")
-- MOD.Lang.Sparkwing:SetRussian("")
MOD.Sparkwing.Name = MOD.Lang.Sparkwing[KBM.Lang]
MOD.Descript = MOD.Sparkwing.Name

-- Ability Dictionary
MOD.Lang.Ability = {}

function MOD:AddBosses(KBM_Boss)
	self.MenuName = self.Descript
	self.Bosses = {
		[self.Sparkwing.Name] = self.Sparkwing,
	}
end

function MOD:InitVars()
	self.Settings = {
		Enabled = true,
		CastBar = self.Sparkwing.Settings.CastBar,
		EncTimer = KBM.Defaults.EncTimer(),
		PhaseMon = KBM.Defaults.PhaseMon(),
		-- MechTimer = KBM.Defaults.MechTimer(),
		-- Alerts = KBM.Defaults.Alerts(),
		-- TimersRef = self.Sparkwing.Settings.TimersRef,
		-- AlertsRef = self.Sparkwing.Settings.AlertsRef,
	}
	KBMEXFCSG_Settings = self.Settings
	chKBMEXFCSG_Settings = self.Settings
	
end

function MOD:SwapSettings(bool)

	if bool then
		KBMEXFCSG_Settings = self.Settings
		self.Settings = chKBMEXFCSG_Settings
	else
		chKBMEXFCSG_Settings = self.Settings
		self.Settings = KBMEXFCSG_Settings
	end

end

function MOD:LoadVars()	
	if KBM.Options.Character then
		KBM.LoadTable(chKBMEXFCSG_Settings, self.Settings)
	else
		KBM.LoadTable(KBMEXFCSG_Settings, self.Settings)
	end
	
	if KBM.Options.Character then
		chKBMEXFCSG_Settings = self.Settings
	else
		KBMEXFCSG_Settings = self.Settings
	end	
end

function MOD:SaveVars()	
	if KBM.Options.Character then
		chKBMEXFCSG_Settings = self.Settings
	else
		KBMEXFCSG_Settings = self.Settings
	end	
end

function MOD:Castbar(units)
end

function MOD:RemoveUnits(UnitID)
	if self.Sparkwing.UnitID == UnitID then
		self.Sparkwing.Available = false
		return true
	end
	return false
end

function MOD:Death(UnitID)
	if self.Sparkwing.UnitID == UnitID then
		self.Sparkwing.Dead = true
		return true
	end
	return false
end

function MOD:UnitHPCheck(unitDetails, unitID)	
	if unitDetails and unitID then
		if not unitDetails.player then
			if unitDetails.name == self.Sparkwing.Name then
				if not self.EncounterRunning then
					self.EncounterRunning = true
					self.StartTime = Inspect.Time.Real()
					self.HeldTime = self.StartTime
					self.TimeElapsed = 0
					self.Sparkwing.Dead = false
					self.Sparkwing.Casting = false
					self.Sparkwing.CastBar:Create(unitID)
					self.PhaseObj:Start(self.StartTime)
					self.PhaseObj:SetPhase(KBM.Language.Options.Single[KBM.Lang])
					self.PhaseObj.Objectives:AddPercent(self.Sparkwing.Name, 0, 100)
					self.Phase = 1
				end
				self.Sparkwing.UnitID = unitID
				self.Sparkwing.Available = true
				return self.Sparkwing
			end
		end
	end
end

function MOD:Reset()
	self.EncounterRunning = false
	self.Sparkwing.Available = false
	self.Sparkwing.UnitID = nil
	self.Sparkwing.CastBar:Remove()
	self.PhaseObj:End(Inspect.Time.Real())
end

function MOD:Timer()	
end

function MOD.Sparkwing:SetTimers(bool)	
	if bool then
		for TimerID, TimerObj in pairs(self.TimersRef) do
			TimerObj.Enabled = TimerObj.Settings.Enabled
		end
	else
		for TimerID, TimerObj in pairs(self.TimersRef) do
			TimerObj.Enabled = false
		end
	end
end

function MOD.Sparkwing:SetAlerts(bool)
	if bool then
		for AlertID, AlertObj in pairs(self.AlertsRef) do
			AlertObj.Enabled = AlertObj.Settings.Enabled
		end
	else
		for AlertID, AlertObj in pairs(self.AlertsRef) do
			AlertObj.Enabled = false
		end
	end
end

function MOD:DefineMenu()
	self.Menu = Instance.Menu:CreateEncounter(self.Sparkwing, self.Enabled)
end

function MOD:Start()
	-- Create Timers
	--KBM.Defaults.TimerObj.Assign(self.Sparkwing)
	
	-- Create Alerts
	--KBM.Defaults.AlertObj.Assign(self.Sparkwing)
	
	-- Assign Alerts and Timers to Triggers
	
	self.Sparkwing.CastBar = KBM.CastBar:Add(self, self.Sparkwing)
	self.PhaseObj = KBM.PhaseMonitor.Phase:Create(1)
	self:DefineMenu()
end