FCBS = {}
FCBS_config = {}

function FCBS.CreateFrame(obj, unit, border, x, y)
	FCBS[obj] = {}
	FCBS[obj].unit = unit
	
	FCBS[obj].context = UI.CreateContext("FCBS_"..obj.."_context")
	
	FCBS[obj].frame = UI.CreateFrame("Frame", "FCBS_"..obj, FCBS[obj].context)
	FCBS[obj].frame:SetWidth(280)
	FCBS[obj].frame:SetHeight(32)
	FCBS[obj].frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", x, y)
	
	FCBS[obj].background = UI.CreateFrame("Texture", "FCBS_"..obj.."_background", FCBS[obj].frame)
	FCBS[obj].background:SetWidth(264)
	FCBS[obj].background:SetHeight(16)
	FCBS[obj].background:SetTexture("fCastBars", "texture\\background.dds")
	FCBS[obj].background:SetPoint("CENTER", FCBS[obj].frame, "CENTER")
	
	FCBS[obj].bar = UI.CreateFrame("Texture", "FCBS_"..obj.."_bar", FCBS[obj].frame)
	FCBS[obj].bar:SetWidth(264)
	FCBS[obj].bar:SetHeight(16)
	FCBS[obj].bar:SetLayer(1)
	FCBS[obj].bar:SetPoint("LEFTCENTER", FCBS[obj].background, "LEFTCENTER")
	
	FCBS[obj].border = UI.CreateFrame("Texture", "FCBS_"..obj.."_border", FCBS[obj].frame)
	FCBS[obj].border:SetTexture("fCastBars", border)
	FCBS[obj].border:SetLayer(2)
	if unit == "player.target" then
		FCBS[obj].border:SetPoint("CENTER", FCBS[obj].frame, "CENTER")
	elseif unit == "player" then
		FCBS[obj].border:SetPoint("CENTER", FCBS[obj].frame, "CENTER", 0, 1)
	else
		FCBS[obj].border:SetPoint("CENTER", FCBS[obj].frame, "CENTER", -11, 0)
	end
	
	FCBS[obj].skill = UI.CreateFrame("Text", "FCBS_"..obj.."_skill", FCBS[obj].frame)
	FCBS[obj].skill:SetFontSize(14)
	FCBS[obj].skill:SetFontColor(1, 1, 1)
	FCBS[obj].skill:SetLayer(3)
	FCBS[obj].skill:SetText(unit)
	FCBS[obj].skill:SetPoint("CENTER", FCBS[obj].frame, "CENTER")
	
	FCBS[obj].count = UI.CreateFrame("Text", "FCBS_"..obj.."_count", FCBS[obj].frame)
	FCBS[obj].count:SetFontSize(14)
	FCBS[obj].count:SetFontColor(1, 1, 1)
	FCBS[obj].count:SetText("0.0/0.0")
	if unit == "player" or unit == "player.target" then
		FCBS[obj].count:SetPoint("CENTERTOP", FCBS[obj].frame, "CENTERBOTTOM", 0, -2)
	else
		FCBS[obj].count:SetPoint("CENTERTOP", FCBS[obj].frame, "CENTERBOTTOM", 0, -6)
	end
		
	FCBS[obj].highlight = UI.CreateFrame("Texture", "FCBS_"..obj.."_highlight", FCBS[obj].frame)
	FCBS[obj].highlight:SetLayer(3)
	FCBS[obj].highlight:SetVisible(false)
	FCBS[obj].highlight:SetTexture("fCastBars", "texture\\highlight.dds")
	FCBS[obj].highlight:SetPoint("CENTER", FCBS[obj].frame, "CENTER", -11, 0)
	
	FCBS[obj].icon = UI.CreateFrame("Texture", "FCBS_"..obj.."_icon", FCBS[obj].frame)
	FCBS[obj].icon:SetWidth(32)
	FCBS[obj].icon:SetHeight(32)
	FCBS[obj].icon:SetLayer(3)
	FCBS[obj].icon:SetPoint("RIGHTCENTER", FCBS[obj].frame, "LEFTCENTER", -4, 0)

	FCBS[obj].iconborder = UI.CreateFrame("Texture", "FCBS_"..obj.."_iconborder", FCBS[obj].icon)
	FCBS[obj].iconborder:SetWidth(48)
	FCBS[obj].iconborder:SetHeight(48)
	FCBS[obj].iconborder:SetLayer(4)
	FCBS[obj].iconborder:SetTexture("fCastBars", "texture\\icon.dds")
	FCBS[obj].iconborder:SetPoint("CENTER", FCBS[obj].icon, "CENTER")
	
	if not FCBS_config[obj] then
		FCBS_config[obj] = {}
		FCBS_config[obj].x = FCBS[obj].frame:GetLeft()
		FCBS_config[obj].y = FCBS[obj].frame:GetTop()
		FCBS_config[obj].on = true
	end
	
	FCBS[obj].frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", FCBS_config[obj].x, FCBS_config[obj].y)
	FCBS[obj].frame:SetVisible(false)
	
	FCBS[obj].mouse = {}
	FCBS[obj].frame.Event.LeftDown = function()
		if FCBS.move then
			local cursor = Inspect.Mouse()
			FCBS[obj].mouse.pressed = true
			FCBS[obj].mouse.x = cursor.x - FCBS[obj].frame:GetLeft()
			FCBS[obj].mouse.y = cursor.y - FCBS[obj].frame:GetTop()
		end
	end

	FCBS[obj].frame.Event.MouseMove = function()
		if FCBS[obj].mouse.pressed and FCBS.move then
			local cursor = Inspect.Mouse()
			local x = cursor.x - FCBS[obj].mouse.x
			local y = cursor.y - FCBS[obj].mouse.y
			FCBS[obj].frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", cursor.x - FCBS[obj].mouse.x, cursor.y - FCBS[obj].mouse.y)
		end
	end

	FCBS[obj].frame.Event.LeftUp = function()
		if FCBS[obj].mouse.pressed and FCBS.move then
			FCBS_config[obj].x = FCBS[obj].frame:GetLeft()
			FCBS_config[obj].y = FCBS[obj].frame:GetTop()
			FCBS[obj].mouse.pressed = nil
		end
	end
end

function FCBS.ResetBars(obj)
	FCBS[obj].cast = Inspect.Unit.Castbar(FCBS[obj].unit)
	if FCBS[obj].cast.uninterruptible then
		FCBS[obj].bar:SetTexture("fCastBars", "texture\\bar_un.dds")
	else
		FCBS[obj].bar:SetTexture("fCastBars", "texture\\bar.dds")
	end
	if FCBS[obj].cast.ability and Inspect.Ability.Detail(FCBS[obj].cast.ability) then
		local ability = Inspect.Ability.Detail(FCBS[obj].cast.ability)
		FCBS[obj].icon:SetTexture("Rift", ability.icon)
		FCBS[obj].icon:SetVisible(true)
	else
		FCBS[obj].icon:SetVisible(false)
	end
	FCBS[obj].skill:SetText(FCBS[obj].cast.abilityName)
	FCBS[obj].highlight:SetVisible(false)
	FCBS[obj].frame:SetAlpha(1)
	FCBS[obj].frame:SetVisible(true)
end

function FCBS.UpdateBars(obj)
	if Inspect.Unit.Castbar(FCBS[obj].unit) then
		FCBS[obj].cast = Inspect.Unit.Castbar(FCBS[obj].unit)
		if FCBS[obj].cast.channeled then
			FCBS[obj].bar:SetWidth(264 * FCBS[obj].cast.remaining / FCBS[obj].cast.duration)
			FCBS[obj].count:SetText(string.format("%.1f", FCBS[obj].cast.remaining).."/"..string.format("%.1f", FCBS[obj].cast.duration))
		else
			FCBS[obj].bar:SetWidth(264 - (264 * FCBS[obj].cast.remaining / FCBS[obj].cast.duration))
			FCBS[obj].count:SetText(string.format("%.1f", FCBS[obj].cast.duration - FCBS[obj].cast.remaining).."/"..string.format("%.1f", FCBS[obj].cast.duration))
		end
	elseif FCBS[obj].frame:GetAlpha() <= 0 or not Inspect.Unit.Lookup(FCBS[obj].unit) then
		FCBS[obj].frame:SetVisible(false)
		FCBS[obj].cast = nil
		FCBS[obj].frame:SetAlpha(1)
	elseif FCBS[obj].cast.remaining > 0 then
		FCBS[obj].bar:SetTexture("fCastBars", "texture\\bar_f.dds")
		FCBS[obj].frame:SetAlpha(FCBS[obj].frame:GetAlpha() - 0.05)
	else
		FCBS[obj].highlight:SetVisible(true)
		FCBS[obj].frame:SetAlpha(FCBS[obj].frame:GetAlpha() - 0.05)
	end
end

function FCBS.OnLoad()
	FCBS.CreateFrame("player", "player", "texture\\border_p.dds", 400, 200)
	FCBS.CreateFrame("target", "player.target", "texture\\border_t.dds", 400, 250)
	FCBS.CreateFrame("targetoftarget", "player.target.target", "texture\\border.dds", 400, 300)
	FCBS.CreateFrame("focus", "focus", "texture\\border.dds", 400, 350)
	
	print("Type /fcbs for list of configure commands.")
end

function FCBS.OnEvent(units)
	if units[Inspect.Unit.Lookup("player")] and FCBS_config["player"].on then
		if Inspect.Unit.Castbar("player") then
			FCBS.ResetBars("player")
		elseif not FCBS.move then
			FCBS["player"].frame:SetVisible(false)
			FCBS["player"].cast = nil
		end
	end
	if units[Inspect.Unit.Lookup("player.target")] and FCBS_config["target"].on then
		if Inspect.Unit.Castbar("player.target") then
			FCBS.ResetBars("target")
		elseif not FCBS.move then
			FCBS["target"].frame:SetVisible(false)
			FCBS["target"].cast = nil
		end
	end
	if units[Inspect.Unit.Lookup("player.target.target")] and FCBS_config["targetoftarget"].on then
		if Inspect.Unit.Castbar("player.target.target") then
			FCBS.ResetBars("targetoftarget")
		elseif not FCBS.move then
			FCBS["targetoftarget"].frame:SetVisible(false)
			FCBS["targetoftarget"].cast = nil
		end
	end
	if units[Inspect.Unit.Lookup("focus")] and FCBS_config["focus"].on then
		if Inspect.Unit.Castbar("focus") then
			FCBS.ResetBars("focus")
		elseif not FCBS.move then
			FCBS["focus"].frame:SetVisible(false)
			FCBS["focus"].cast = nil
		end
	end
end

function FCBS.OnUpdate()
	if FCBS["player"].cast then
		FCBS.UpdateBars("player")
	end
	if FCBS["target"].cast then
		FCBS.UpdateBars("target")
	end
	if FCBS["targetoftarget"].cast then
		FCBS.UpdateBars("targetoftarget")
	end
	if FCBS["focus"].cast then
		FCBS.UpdateBars("focus")
	end
end

function FCBS.SlashMove()
	if FCBS.move then
		FCBS["player"].frame:SetVisible(false)
		FCBS["target"].frame:SetVisible(false)
		FCBS["targetoftarget"].frame:SetVisible(false)
		FCBS["focus"].frame:SetVisible(false)
		FCBS.move = nil
	else
		FCBS["player"].frame:SetVisible(true)
		FCBS["target"].frame:SetVisible(true)
		FCBS["targetoftarget"].frame:SetVisible(true)
		FCBS["focus"].frame:SetVisible(true)
		FCBS["player"].frame:SetAlpha(1)
		FCBS["target"].frame:SetAlpha(1)
		FCBS["targetoftarget"].frame:SetAlpha(1)
		FCBS["focus"].frame:SetAlpha(1)
		FCBS.move = true
	end
end

function FCBS.SlashHelp()
	print("Type /fcbs-move to move bars, type this again after moving.")
	print("Type /fcbs-p-on or /fcbs-p-off to turn on/off the player castbar.")
	print("Type /fcbs-t-on or /fcbs-t-off to turn on/off the target castbar.")
	print("Type /fcbs-tt-on or /fcbs-tt-off to turn on/off the target of target castbar.")
	print("Type /fcbs-f-on or /fcbs-f-off to turn on/off the focus castbar.")
end

table.insert(Event.Addon.SavedVariables.Load.End, {FCBS.OnLoad, "fCastBars", "FCBS_OnLoad"})
table.insert(Event.Unit.Add, {FCBS.OnEvent, "fCastBars", "FCBS_OnEvent"})
table.insert(Event.Unit.Castbar, {FCBS.OnEvent, "fCastBars", "FCBS_OnEvent"})
table.insert(Event.System.Update.Begin, {FCBS.OnUpdate, "fCastBars", "FCBS_OnUpdate"})
table.insert(Command.Slash.Register("fcbs"), {FCBS.SlashHelp, "fCastBars", "FCBS_OnSlash" })
table.insert(Command.Slash.Register("fcbs-move"), {FCBS.SlashMove, "fCastBars", "FCBS_OnSlash" })
table.insert(Command.Slash.Register("fcbs-p-on"), {function() FCBS_config["player"].on = true; print("Player castbar turned on.") end, "fCastBars", "FCBS_OnSlash" })
table.insert(Command.Slash.Register("fcbs-t-on"), {function() FCBS_config["target"].on = true; print("Target castbar turned on.") end, "fCastBars", "FCBS_OnSlash" })
table.insert(Command.Slash.Register("fcbs-tt-on"), {function() FCBS_config["targetoftarget"].on = true; print("Target of target castbar turned on.") end, "fCastBars", "FCBS_OnSlash" })
table.insert(Command.Slash.Register("fcbs-f-on"), {function() FCBS_config["focus"].on = true; print("Focus castbar turned on.") end, "fCastBars", "FCBS_OnSlash" })
table.insert(Command.Slash.Register("fcbs-p-off"), {function() FCBS_config["player"].on = false; print("Player castbar turned off.") end, "fCastBars", "FCBS_OnSlash" })
table.insert(Command.Slash.Register("fcbs-t-off"), {function() FCBS_config["target"].on = false; print("Target castbar turned off.") end, "fCastBars", "FCBS_OnSlash" })
table.insert(Command.Slash.Register("fcbs-tt-off"), {function() FCBS_config["targetoftarget"].on = false; print("Target of target castbar turned off.") end, "fCastBars", "FCBS_OnSlash" })
table.insert(Command.Slash.Register("fcbs-f-off"), {function() FCBS_config["focus"].on = false; print("Focus castbar turned off.") end, "fCastBars", "FCBS_OnSlash" })