--[[-------------------------------------------------------------------------
Display bar for specific useful information
This is a work in progress. There is still a lot to be done.

TO DO list(this list is in no way complete):
	1. add more items to display
		a. vitality
		b. exp?
		c. ...
	2. Implement a saved variables file
	3. Make the frame draggable, and make the fields movable inside the frame
-------------------------------------------------------------------------]]--


-----------------------------------------------------------------------------
------------------- The stuff that happens for every addon ------------------
-----------------------------------------------------------------------------
addon = ...
local nivStatsContext = UI.CreateContext("nivStatsContext")
local curFrameCheck = false
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------



-----------------------------------------------------------------------------
----------------------------- Settings Section ------------------------------
-----------------------------------------------------------------------------
local modules = {							-- available modules and the position you want it at
					bSlotsSlot = 2,			-- slot position for Bag Slots Module
					moneySlot = 1,			-- slot position for Curreny Module
					vitalitySlot = 3
}

local c = {
	b1 = {  -- Settings for the first frame
		Height = 25,
		Width = 250,  -- DO NOT MODIFY, this value is a default, and actually changes on load based on what modules are loaded and their respective widths
		BGColor = { r = 0, g = 0, b = 0, a = .5 },					
		anchorAt = "TOPCENTER",
		anchorTo = "TOPCENTER",
		x = 0,
		y = 50,
		
		p1 = {	-- Bar 1, position 1, settings
			FontSize = 14,
			anchorAt = "CENTERLEFT",
			anchrTo = "CENTERLEFT",
			x = 5,
			y = 0,
		},
		
		p2 = {  -- Bar 1, position 2, settings
			FontSize = 14,
			anchorAt = "CENTERLEFT",
			anchrTo = "CENTERRIGHT",
			x = 25,
			y = 0,
		},
		
		p3 = {  -- Bar 1, position 2, settings
			FontSize = 14,
			anchorAt = "CENTERLEFT",
			anchrTo = "CENTERRIGHT",
			x = 25,
			y = 0,
		}
	
	}
}
	
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------

-----------------------------------------------------------------------------
------------------ Do not modify anything below this line -------------------
-----------------------------------------------------------------------------
playerInfo = {}

-- Create the first bar
local b1 = UI.CreateFrame("Frame", "b1", nivStatsContext) 
			b1:SetHeight(c.b1.Height)
			b1:SetWidth(c.b1.Width)
			b1:SetBackgroundColor(c.b1.BGColor.r, c.b1.BGColor.g, c.b1.BGColor.b, c.b1.BGColor.a)
			b1:SetPoint(c.b1.anchorAt, UIParent, c.b1.anchorTo, c.b1.x, c.b1.y)
			b1:SetLayer(1)


-- Create the slots for the first bar
local b1slots = {
		UI.CreateFrame("Frame", "b1p1", b1),
		UI.CreateFrame("Text", "b1p2", b1),
		UI.CreateFrame("Text", "b1p3", b1)
}

-- Set the font size for each position
--b1slots[2]:SetFontSize(c.b1.p2.FontSize)
--b1slots[3]:SetFontSize(c.b1.p3.FontSize)

-- Set the position for each "position"
b1slots[1]:SetPoint(c.b1.p1.anchorAt, b1, c.b1.p1.anchrTo, c.b1.p1.x, c.b1.p1.y)
b1slots[1]:SetLayer(2)
b1slots[2]:SetPoint(c.b1.p2.anchorAt, b1slots[1], c.b1.p2.anchrTo, c.b1.p2.x, c.b1.p2.y)
b1slots[2]:SetLayer(2)
b1slots[3]:SetPoint(c.b1.p3.anchorAt, b1slots[2], c.b1.p3.anchrTo, c.b1.p3.x, c.b1.p3.y)
b1slots[3]:SetLayer(2)


-- This is for lack of better words main()
function refresh()
	playerInfo = Inspect.Unit.Detail("player")
	eventID = 0
	if modules.bSlotsSlot > 0 then
		bSlotsSlotWidth = bagSlots()
	end
	if modules.moneySlot > 0 then
		moneySlotWidth = currency()
	end
	if modules.vitalitySlot > 0 then
		vitalitySlotWidth = vitality()
	end
	if not nivUI then
		totalModWidth = bSlotsSlotWidth + moneySlotWidth + vitalitySlotWidth
	
		b1Width = c.b1.p1.x + c.b1.p2.x + c.b1.p3.x + totalModWidth + c.b1.p1.x
		b1:SetWidth(b1Width)
	end
	
	-- Clears the on-load event from the table since its not really an onload event
	for k,v in pairs(Event.System.Update.End) do
		if v[2] == "nivStats" then
			eventID = k
		end
	end
	table.remove(Event.System.Update.End, eventID)
end

---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------

-- Bagslot Module
function bagSlots()
	slotInfo = Inspect.Item.List()
	slot = modules.bSlotsSlot
	totalSlots = 0
	emptySlots = 0

	for k, v in pairs(slotInfo) do
		if string.sub(k, 0, 2) == "si" and string.sub(k, 3, 4) ~= "bg" then
			totalSlots = totalSlots + 1
			if v == false then
				emptySlots = emptySlots + 1
			end
		end
	end
	--Place the count on the bar
	bagSlotString = string.format("B: %d/%d", emptySlots, totalSlots)
	b1slots[slot]:SetText(bagSlotString)
	return b1slots[slot]:GetWidth()
end

---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------

-- Currency Module
function currency()
	if curFrameCheck == false then
		platFrame = UI.CreateFrame("Texture", "plat", b1)
		platAmountFrame = UI.CreateFrame("Text", "platAmount", b1)
		goldFrame = UI.CreateFrame("Texture", "gold", b1)
		goldAmountFrame = UI.CreateFrame("Text", "goldAmount", b1)
		silverFrame = UI.CreateFrame("Texture", "silver", b1)
		silverAmountFrame = UI.CreateFrame("Text", "silverAmount", b1)
		curFrameCheck = true
	end
	slot = modules.moneySlot
	currencyTemp = Inspect.Currency.Detail("coin")


	if currencyTemp.stack ~= nil then
		len = string.len(currencyTemp.stack) -- we need this to determine how much currency we have
		local f = b1slots[slot]
		
		if len > 0 then
			silverAmountFrame:SetText(string.sub(currencyTemp.stack, len-1, len))	
			if len > 2 then
				goldAmountFrame:SetText(string.sub(currencyTemp.stack, len-3, len-2))
				if len > 4 then
					platAmountFrame:SetText(string.sub(currencyTemp.stack, 1, len-4))
				else
					platAmountFrame:SetText("0")
				end
			else
				goldAmountFrame:SetText("0")
				platAmountFrame:SetText("0")
			end
		else
			silverAmountFrame:SetText("0")
			goldAmountFrame:SetText("0")
			platAmountFrame:SetText("0")
		end
		
		--this is messy as shit and rediculously long do to not being able to format strings in pieces
		
		platFrame:SetTexture("nivStats", "Textures\\plat.png")
		silverFrame:SetTexture("nivStats", "Textures\\silver.png")
		goldFrame:SetTexture("nivStats", "Textures\\gold.png")
		platFrame:SetPoint("CENTERLEFT", b1slots[slot], "CENTERLEFT", 0, 0)
		platAmountFrame:SetPoint("CENTERLEFT", platFrame, "CENTERRIGHT", -2, 0)
		goldFrame:SetPoint("CENTERLEFT", platAmountFrame, "CENTERRIGHT", 2, 0)
		goldAmountFrame:SetPoint("CENTERLEFT", goldFrame, "CENTERRIGHT", -2, 0)
		silverFrame:SetPoint("CENTERLEFT", goldAmountFrame, "CENTERRIGHT", -2, 0)
		silverAmountFrame:SetPoint("CENTERLEFT", silverFrame, "CENTERRIGHT", -2, 0)
					
		currencyWidth = platFrame:GetWidth() + platAmountFrame:GetWidth() + goldFrame:GetWidth() + goldAmountFrame:GetWidth() + silverFrame:GetWidth() + silverAmountFrame:GetWidth() - 6
		f:SetWidth(currencyWidth)
		f:SetMouseMasking("limited")
		f.Event.MouseIn = function(...) curMousein(slot) end
		f.Event.MouseOut = function(...) curMouseout() end		
		
		return b1slots[slot]:GetWidth()
	else
		return 0
	end

--eventually this will have a tooltip that will show you all the currencies you have and the amounts
end

local curToolTip = UI.CreateFrame("Frame","curToolTip",b1)
	curToolTip:SetPoint("TOPLEFT", b1, "BOTTOMLEFT", 0, 2)
	curToolTip:SetBackgroundColor(0, 0, 0, .5)
	curToolTip:SetHeight(305)
	curToolTip:SetWidth(300)
	curToolTip:SetVisible(false)
	
local pvp_icon = UI.CreateFrame("Texture","Favor Icon",curToolTip) 
local master_plaq = UI.CreateFrame("Texture","Master Craftsmen Mark",curToolTip)
local art_mark = UI.CreateFrame("Texture","Artisan Mark",curToolTip)
local planarite = UI.CreateFrame("Texture","Planarite",curToolTip)
local corr_ss = UI.CreateFrame("Texture","Corrupted Sourcestone",curToolTip)
local curse_ss = UI.CreateFrame("Texture","Cursed Sourcestone",curToolTip)
local vile_ss = UI.CreateFrame("Texture","Vile Sourcestone",curToolTip)
local in_ss = UI.CreateFrame("Texture","Inscribed Sourcestone",curToolTip)
local luck_coin = UI.CreateFrame("Texture","Lucky Coin",curToolTip)
local achieve_plaq = UI.CreateFrame("Texture","Plaque of Achievement",curToolTip)
local moa = UI.CreateFrame("Texture","Mark of Ascension",curToolTip)
local gmoa = UI.CreateFrame("Texture","Greater Mark of Ascension",curToolTip)
	
local favor = UI.CreateFrame("Text","Favor",curToolTip)
local master_plaq_text = UI.CreateFrame("Text","Master Craftsman's Mark",curToolTip)
local art_text = UI.CreateFrame("Text","Artisan's Mark",curToolTip)
local plan_text = UI.CreateFrame("Text","Planarite",curToolTip)
local corr_text = UI.CreateFrame("Text","Corrupted Sourcestone",curToolTip)
local curse_text = UI.CreateFrame("Text","Cursed Sourcestone",curToolTip)
local vile_text = UI.CreateFrame("Text","Vile Sourcestone",curToolTip)
local in_text = UI.CreateFrame("Text","Inscribed Sourcestone",curToolTip)
local luck_text = UI.CreateFrame("Text","Lucky Coin",curToolTip)
local ap_text = UI.CreateFrame("Text","Plaques of Achievement",curToolTip)
local moa_text = UI.CreateFrame("Text","Marks of Ascension",curToolTip)
local gmoa_text = UI.CreateFrame("Text","Greater Marks of Ascension",curToolTip)

local favor_amount = UI.CreateFrame("Text","Favor",curToolTip)
local master_amount = UI.CreateFrame("Text","Master Craftsman's Mark",curToolTip)
local art_amount = UI.CreateFrame("Text","Artisan's Mark",curToolTip)
local plan_amount = UI.CreateFrame("Text","Planarite",curToolTip)
local corr_amount = UI.CreateFrame("Text","Corrupted Sourcestone",curToolTip)
local curse_amount = UI.CreateFrame("Text","Cursed Sourcestone",curToolTip)
local vile_amount = UI.CreateFrame("Text","Vile Sourcestone",curToolTip)
local in_amount = UI.CreateFrame("Text","Inscribed Sourcestone",curToolTip)
local luck_amount = UI.CreateFrame("Text","Lucky Coin",curToolTip)
local ap_amount = UI.CreateFrame("Text","Plaques of Achievement",curToolTip)
local moa_amount = UI.CreateFrame("Text","Marks of Ascension",curToolTip)
local gmoa_amount = UI.CreateFrame("Text","Greater Marks of Ascension",curToolTip)

local curTipIcons = {
					pvp_icon, 
					master_plaq,
					art_mark,
					planarite,
					corr_ss,
					curse_ss,
					vile_ss,
					in_ss,
					luck_coin,
					achieve_plaq,
					moa,
					gmoa,
}

local curTipText = {
					favor,
					master_plaq_text,
					art_text,
					plan_text,
					corr_text,
					curse_text,
					vile_text,
					in_text,
					luck_text,
					ap_text,
					moa_text,
					gmoa_text,
}

local curTipAmount = {
					favor_Amount,
					master_plaq_Amount,
					art_Amount,
					plan_Amount,
					corr_Amount,
					curse_Amount,
					vile_Amount,
					in_Amount,
					luck_Amount,
					ap_Amount,
					moa_Amount,
					gmoa_Amount,
}

local curTipLength = table.maxn(curTipText)

function currencyToolTip()
	curSetText()
	curSetAmount()
	curSetIcon()
end

function curSetText()
	favor:SetText("Favor: ")
	plan_text:SetText("Planarite: ")
	corr_text:SetText("Corrupted Sourcestones: ")
	curse_text:SetText("Cursed Sourcestones: ")
	vile_text:SetText("Vile Sourcestones: ")
	in_text:SetText("Inscribed Sourcestones: ")
	ap_text:SetText("Plaques of Achievement: ")
	moa_text:SetText("Marks of Ascension: ")
	gmoa_text:SetText("Greater Marks of Ascension: ")
	luck_text:SetText("Lucky Coins: ")
	master_plaq_text:SetText("Master Craftsman's Mark: ")
	art_text:SetText("Artisan's Mark: ")
	
	favor:SetPoint("CENTERLEFT",pvp_icon,"CENTERRIGHT",5,0)
	plan_text:SetPoint("CENTERLEFT",planarite,"CENTERRIGHT",5,0)
	corr_text:SetPoint("CENTERLEFT",corr_ss,"CENTERRIGHT",5,0)
	curse_text:SetPoint("CENTERLEFT",curse_ss,"CENTERRIGHT",5,0)
	vile_text:SetPoint("CENTERLEFT",vile_ss,"CENTERRIGHT",5,0)
	in_text:SetPoint("CENTERLEFT",in_ss,"CENTERRIGHT",5,0)
	ap_text:SetPoint("CENTERLEFT",achieve_plaq,"CENTERRIGHT",5,0)
	moa_text:SetPoint("CENTERLEFT",moa,"CENTERRIGHT",5,0)
	gmoa_text:SetPoint("CENTERLEFT",gmoa,"CENTERRIGHT",5,0)
	luck_text:SetPoint("CENTERLEFT",luck_coin,"CENTERRIGHT",5,0)
	master_plaq_text:SetPoint("CENTERLEFT",master_plaq,"CENTERRIGHT",5,0)
	art_text:SetPoint("CENTERLEFT",art_mark,"CENTERRIGHT",5,0)
end

local currTemp = {}
function GetStack(a)
	local list = Inspect.Currency.List()
    local stack = -1
	local stackMax = -1
    for k,j in pairs(list) do
        currTemp[j] = Inspect.Currency.Detail(k)
        if currTemp[j].name == a then
			if a == "Planarite" then
				stackMax = currTemp[j].stackMax
			end
            stack = currTemp[j].stack
            break
        else
            stack = 0
        end
    end
    if not stack then
        stack = -1
    end
	if a == "Planarite" then
		stack = tostring(stack) .. "/" .. tostring(stackMax)
	else
		stack = tostring(stack)
	end
	return stack
end

function curSetAmount()
    favor_amount:SetText(GetStack("Favor"))
    plan_amount:SetText(GetStack("Planarite"))
    master_amount:SetText(GetStack("Master Craftsman's Mark"))
    art_amount:SetText(GetStack("Artisan's Mark"))
    corr_amount:SetText(GetStack("Corrupted Sourcestone"))
    curse_amount:SetText(GetStack("Cursed Sourcestone"))
    vile_amount:SetText(GetStack("Vile Sourcestone"))
    in_amount:SetText(GetStack("Inscribed Sourcestone"))
    luck_amount:SetText(GetStack("Lucky Coin"))
    ap_amount:SetText(GetStack("Plaque of Achievement"))
    moa_amount:SetText(GetStack("Mark of Ascension"))
    gmoa_amount:SetText(GetStack("Greater Mark of Ascension"))
	
	favor_amount:SetPoint("TOPRIGHT",curToolTip,"TOPRIGHT",-5,5)
    plan_amount:SetPoint("TOPRIGHT",favor_amount,"TOPRIGHT",0,25)
    corr_amount:SetPoint("TOPRIGHT",plan_amount,"TOPRIGHT",0,25)
    curse_amount:SetPoint("TOPRIGHT",corr_amount,"TOPRIGHT",0,25)
    vile_amount:SetPoint("TOPRIGHT",curse_amount,"TOPRIGHT",0,25)
    in_amount:SetPoint("TOPRIGHT",vile_amount,"TOPRIGHT",0,25)
    ap_amount:SetPoint("TOPRIGHT",in_amount,"TOPRIGHT",0,25)
    moa_amount:SetPoint("TOPRIGHT",ap_amount,"TOPRIGHT",0,25)
    gmoa_amount:SetPoint("TOPRIGHT",moa_amount,"TOPRIGHT",0,25)
	luck_amount:SetPoint("TOPRIGHT",gmoa_amount,"TOPRIGHT",0,25)
	master_amount:SetPoint("TOPRIGHT",luck_amount,"TOPRIGHT",0,25)
    art_amount:SetPoint("TOPRIGHT",master_amount,"TOPRIGHT",0,25)

end

function curSetIcon()
	pvp_icon:SetHeight(20)
	planarite:SetHeight(20)
	corr_ss:SetHeight(20)
	curse_ss:SetHeight(20)
	vile_ss:SetHeight(20)
	in_ss:SetHeight(20)
	achieve_plaq:SetHeight(20)
	moa:SetHeight(20)
	gmoa:SetHeight(20)
	luck_coin:SetHeight(20)
	master_plaq:SetHeight(20)
	art_mark:SetHeight(20)
	
	pvp_icon:SetWidth(20)
	planarite:SetWidth(20)
	corr_ss:SetWidth(20)
	curse_ss:SetWidth(20)
	vile_ss:SetWidth(20)
	in_ss:SetWidth(20)
	achieve_plaq:SetWidth(20)
	moa:SetWidth(20)
	gmoa:SetWidth(20)
	luck_coin:SetWidth(20)
	master_plaq:SetWidth(20)
	art_mark:SetWidth(20)
	
	pvp_icon:SetTexture("Rift","item_icons\\trinket5.dds")
	planarite:SetTexture("Rift","item_icons\\planarite_orb_b.dds")
	corr_ss:SetTexture("Rift","item_icons\\sourcestone_04.dds")
	curse_ss:SetTexture("Rift","item_icons\\sourcestone_02z_z.dds")
	vile_ss:SetTexture("Rift","item_icons\\sourcestone_01.dds")
	in_ss:SetTexture("Rift","item_icons\\mystical_stone1.dds")
	achieve_plaq:SetTexture("Rift","item_icons\\plaque_of_achievement.dds")
	moa:SetTexture("Rift","item_icons\\card30c.dds")
	gmoa:SetTexture("Rift","item_icons\\card30a.dds")
	luck_coin:SetTexture("Rift","item_icons\\trinket8.dds")
	master_plaq:SetTexture("Rift","item_icons\\card28a.dds")
	art_mark:SetTexture("Rift","item_icons\\trinket27a.dds")
	
	pvp_icon:SetPoint("TOPLEFT",curToolTip,"TOPLEFT",5,5)
	planarite:SetPoint("TOPLEFT",pvp_icon,"BOTTOMLEFT",0,5)
	corr_ss:SetPoint("TOPLEFT",planarite,"BOTTOMLEFT",0,5)
	curse_ss:SetPoint("TOPLEFT",corr_ss,"BOTTOMLEFT",0,5)
	vile_ss:SetPoint("TOPLEFT",curse_ss,"BOTTOMLEFT",0,5)
	in_ss:SetPoint("TOPLEFT",vile_ss,"BOTTOMLEFT",0,5)
	achieve_plaq:SetPoint("TOPLEFT",in_ss,"BOTTOMLEFT",0,5)
	moa:SetPoint("TOPLEFT",achieve_plaq,"BOTTOMLEFT",0,5)
	gmoa:SetPoint("TOPLEFT",moa,"BOTTOMLEFT",0,5)
	luck_coin:SetPoint("TOPLEFT",gmoa,"BOTTOMLEFT",0,5)
	master_plaq:SetPoint("TOPLEFT",luck_coin,"BOTTOMLEFT",0,5)
	art_mark:SetPoint("TOPLEFT",master_plaq,"BOTTOMLEFT",0,5)
end

function curFixTip()

end

function curMousein(slot)
	currencyToolTip()
	curToolTip:SetVisible(true)
end

function curMouseout()
	curToolTip:SetVisible(false)
end

---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------

-- Vitality Module
function vitality()
	slot = modules.vitalitySlot
	if playerInfo.vitality ~= nil then
		vitalityString = string.format("V: %d", playerInfo.vitality)
		b1slots[slot]:SetText(vitalityString)
		return b1slots[slot]:GetWidth()
	else
		return 0
	end
end

---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------	
---------------------------------------------------------------------------------------------------------

-- Register the events that will trigger the changes
table.insert(Event.System.Update.End, { refresh, "nivStats", "Refresh Modules" })
table.insert(Event.Item.Slot, { refresh, "nivStats", "Refresh Modules" })
table.insert(Event.Item.Update, { refresh, "nivStats", "Refresh Modules" })
table.insert(Event.Currency, { refresh, "nivStats", "Refresh Modules" })